# Mini-project #6 - Blackjack

import simplegui
import random

# load card sprite - 949x392 - source: jfitz.com
CARD_SIZE = (73, 98)
CARD_CENTER = (36.5, 49)
card_images = simplegui.load_image("http://commondatastorage.googleapis.com/codeskulptor-assets/cards.jfitz.png")

CARD_BACK_SIZE = (71, 96)
CARD_BACK_CENTER = (35.5, 48)
card_back = simplegui.load_image("http://commondatastorage.googleapis.com/codeskulptor-assets/card_back.png")    
desert = simplegui.load_image("C:\Users\Public\Pictures\Sample Pictures\Desert.jpg")
# initialize some useful global variables
in_play = False
outcome = ""
player_score = 0
dealer_score = 0
# define globals for cards
SUITS = ('C', 'S', 'H', 'D')
RANKS = ('A', '2', '3', '4', '5', '6', '7', '8', '9', 'T', 'J', 'Q', 'K')
VALUES = {'A':1, '2':2, '3':3, '4':4, '5':5, '6':6, '7':7, '8':8, '9':9, 'T':10, 'J':10, 'Q':10, 'K':10}


# define card class
class Card:
    def __init__(self, suit, rank):
        if (suit in SUITS) and (rank in RANKS):
            self.suit = suit
            self.rank = rank
        else:
            self.suit = None
            self.rank = None
            print "Invalid card: ", suit, rank

    def __str__(self):
        return self.suit + self.rank

    def get_suit(self):
        return self.suit

    def get_rank(self):
        return self.rank

    def draw(self, canvas, pos):
        card_loc = (CARD_CENTER[0] + CARD_SIZE[0] * RANKS.index(self.rank), 
                    CARD_CENTER[1] + CARD_SIZE[1] * SUITS.index(self.suit))
        canvas.draw_image(card_images, card_loc, CARD_SIZE, [pos[0] + CARD_CENTER[0], pos[1] + CARD_CENTER[1]], CARD_SIZE)
        
# define hand class
class Hand:
    hand_list=[]
    def __init__(self):
        self.hand_list = []
        pass	# create Hand object

    def __str__(self):
        ans = ""
        for i in range(len(self.hand_list)):
            ans = ans + str(self.hand_list[i]) + " "
        return "Hand Contains " + ans	# return a string representation of a hand

    def add_card(self, card):
        self.hand_list.append(card)
        pass	# add a card object to a hand
     
    def get_value(self):
        sum = 0       
        flag = False
        
        for i in self.hand_list:
            if(i.rank == 'A'):
                flag = True
            sum += VALUES[i.rank]        
                
        if flag:
            a = sum + 10
            if a <=21:
                return (sum+10)
            else:
                return sum
        else:
            return sum
        # count aces as 1, if the hand has an ace, then add 10 to hand value if it doesn't bust
        # compute the value of the hand, see Blackjack video
   
    def draw(self, canvas, pos):
        temp = 40
        for i in self.hand_list:
            Card.draw(i,canvas,[pos[0]+temp,pos[1]])
            temp += 77
        pass	# draw a hand on the canvas, use the draw method for cards
 

        
# define deck class 
class Deck:
    deck_list = []
    def __init__(self):
        self.deck_list = []
        for i in range(len(SUITS)):
            for j in range(len(RANKS)):
                temp_card = Card(SUITS[i],RANKS[j])
                self.deck_list.append(temp_card)

    def shuffle(self):
        random.shuffle(self.deck_list)
        # shuffle the deck 
        pass    # use random.shuffle()

    def deal_card(self):
        global deck_list
        r_cn = len(self.deck_list) - 1
        top_card = Card(self.deck_list[r_cn].suit,self.deck_list[r_cn].rank)
        self.deck_list.pop(r_cn)
        return top_card
        # deal a card object from the deck
    
    def __str__(self):
        ans = ""
        for i in range(len(self.deck_list)):
            ans = ans+ " " + str(self.deck_list[i]) 
        return "Deck contaains"+ans
        # return a string representing the deck


#define event handlers for buttons
def deal():
    global outcome, in_play
    global deck
    global player_hand, dealer_hand
    deck = Deck()
    deck.shuffle()
    print deck
    player_hand = Hand()
    dealer_hand = Hand()
    player_hand.add_card(Deck.deal_card(deck))
    player_hand.add_card(Deck.deal_card(deck))
    dealer_hand.add_card(Deck.deal_card(deck))
    dealer_hand.add_card(Deck.deal_card(deck))
    
    print "Player Hand: ",player_hand
    print "Dealer Hand: ",dealer_hand
    
    print deck
    # your code goes here
    
    in_play = True
    outcome = ""
    

def hit():
    global player_score,dealer_score
    global player_hand
    global outcome
    hand_value = Hand.get_value(player_hand)
    if(hand_value <= 21):
        player_hand.add_card(Deck.deal_card(deck))
        hand_value2 = Hand.get_value(player_hand)
        if(hand_value2 > 21):
            print "You have been busted"
            outcome = "Player busted...Dealer wins..."
            dealer_score += 1
    print "Player Hand..:: " ,player_hand    
    pass	# replace with your code below
 
    # if the hand is in play, hit the player
   
    # if busted, assign a message to outcome, update in_play and score
       
def stand():
    global player_score,dealer_score
    global outcome
    if(Hand.get_value(player_hand) > 21):
        print "Cant stand..!! You have already been busted"
        outcome = "Cant stand..!! You have already been busted"
    else:
        while Hand.get_value(dealer_hand) <=17:
            dealer_hand.add_card(Deck.deal_card(deck))
            print "Dealer Hand",dealer_hand
            if Hand.get_value(dealer_hand) >21:
                print "dealer has been busted..!!! "
                outcome = "Dealer busted....Player wins"
                player_score += 1
    p_hand = Hand.get_value(player_hand)
    d_hand = Hand.get_value(dealer_hand)
    if(p_hand <=21 and d_hand<=21):
        if(p_hand > d_hand):
            print "Player wins"
            outcome = "Player wins"
            player_score += 1
        else:
            print "Dealer wins"
            outcome = "Dealer wins"
            dealer_score += 1
            
    pass	# replace with your code below
   
    # if hand is in play, repeatedly hit dealer until his hand has value 17 or more

    # assign a message to outcome, update in_play and score

# draw handler    
def draw(canvas):
    global player_hand
    global player_score,dealer_score
    global CARD_BACK_SIZE,card_back,CARD_BACK_CENTER
    canvas.draw_text("...BLACK JACK...",[100,50],34,"Maroon")
    canvas.draw_image(card_back,[CARD_BACK_CENTER[0],CARD_BACK_CENTER[1]], CARD_BACK_SIZE, [160,190], CARD_BACK_SIZE)    
        
    if(in_play):
        canvas.draw_text("Dealer Hand :",[80,150],38,"Black")
        Hand.draw(dealer_hand,canvas,[80,160])        
        
        canvas.draw_text("Player Hand :",[80,300],38,"Black")
        canvas.draw_text("Hit or stand ?",[80,340],28,"Red")
        Hand.draw(player_hand,canvas,[80,360])
        
        canvas.draw_text(""+outcome,[80,520],28,"Black")
        canvas.draw_text("Player score"+str(player_score),[80,100],18,"Yellow")
        canvas.draw_text("Dealer score"+str(dealer_score),[280,100],18,"Yellow")
        
        
    #card = Card("D", "A")
    #card.draw(canvas, [300, 300])


# initialization frame
frame = simplegui.create_frame("Blackjack", 600, 600)
frame.set_canvas_background("Green")

#create buttons and canvas callback
frame.add_button("Deal", deal, 200)
frame.add_button("Hit",  hit, 200)
frame.add_button("Stand", stand, 200)
frame.set_draw_handler(draw)


# get things rolling
frame.start()


# remember to review the gradic rubric